Index: /trunk/src/subprojects/network/network_unit_test.cc
===================================================================
--- /trunk/src/subprojects/network/network_unit_test.cc	(revision 6138)
+++ /trunk/src/subprojects/network/network_unit_test.cc	(revision 6139)
@@ -11,4 +11,5 @@
 #include "network_stream.h"
 #include "synchronizeable.h"
+#include "converter.h"
 
 #include "simple_sync.h"
@@ -40,19 +41,19 @@
   server.listen(9999);
 
-  NetworkSocket client1(ip);
-
-  NetworkSocket server1 = server.getNewSocket();
-
-  NetworkSocket client2(ip);
-
-  NetworkSocket server2 = server.getNewSocket();
+  NetworkSocket* client1 = new NetworkSocket(ip);
+
+  NetworkSocket* server1 = server.getNewSocket();
+
+  NetworkSocket* client2 = new NetworkSocket(ip);
+
+  NetworkSocket* server2 = server.getNewSocket();
 
   char buf[1024];
 
   printf("read from client1 before sending data\n");
-  printf("result: %d bytes\n", client1.readPacket((byte*)buf, 1024));
+  printf("result: %d bytes\n", client1->readPacket((byte*)buf, 1024));
 
   printf("read from client2 before sending data\n");
-  printf("result: %d bytes\n", client2.readPacket((byte*)buf, 1024));
+  printf("result: %d bytes\n", client2->readPacket((byte*)buf, 1024));
 
   int n;
@@ -61,16 +62,16 @@
   char * str3 = "client2 to server";
   char * str4 = "server2 to client";
-  n = client1.writePacket((byte*)str1, strlen(str1)+1);
+  n = client1->writePacket((byte*)str1, strlen(str1)+1);
   printf("%d bytes send from client1\n", n);
-  n = server1.writePacket((byte*)str2, strlen(str2)+1);
+  n = server1->writePacket((byte*)str2, strlen(str2)+1);
   printf("%d bytes send from server1\n", n);
-  n = client2.writePacket((byte*)str3, strlen(str3)+1);
+  n = client2->writePacket((byte*)str3, strlen(str3)+1);
   printf("%d bytes send from client2\n", n);
-  n = server2.writePacket((byte*)str4, strlen(str4)+1);
+  n = server2->writePacket((byte*)str4, strlen(str4)+1);
   printf("%d bytes send from server2\n", n);
   SDL_Delay(1000);
 
   printf("read from server1\n");
-  n = server1.readPacket((byte*)buf, 1024);
+  n = server1->readPacket((byte*)buf, 1024);
   printf("read %d bytes\n", n);
   if (n<0)
@@ -80,5 +81,5 @@
 
   printf("read from server2\n");
-  n = server2.readPacket((byte*)buf, 1024);
+  n = server2->readPacket((byte*)buf, 1024);
   printf("read %d bytes\n", n);
   if (n<0)
@@ -88,5 +89,5 @@
 
   printf("read from client1\n");
-  n = client1.readPacket((byte*)buf, 1024);
+  n = client1->readPacket((byte*)buf, 1024);
   printf("read %d bytes\n", n);
   if (n<0)
@@ -96,5 +97,5 @@
 
   printf("read from client2\n");
-  n = client2.readPacket((byte*)buf, 1024);
+  n = client2->readPacket((byte*)buf, 1024);
   printf("read %d bytes\n", n);
   if (n<0)
@@ -106,10 +107,10 @@
 
   printf("try to send more than 255 bytes\n");
-  printf("result: %d\n", client1.writePacket((byte*)buf, 1000));
-
-  server1.writePacket((byte*)str1, strlen(str1)+1);
+  printf("result: %d\n", client1->writePacket((byte*)buf, 1000));
+
+  server1->writePacket((byte*)str1, strlen(str1)+1);
   SDL_Delay(500);
   printf("try to read with a too small buffer\n");
-  printf("result: %d\n", client1.readPacket((byte*)buf, strlen(str1)));
+  printf("result: %d\n", client1->readPacket((byte*)buf, strlen(str1)));
 
   return 0;
@@ -190,5 +191,5 @@
   Synchronizeable* ss = new SimpleSync("Server\0");
 
-  netMan->createServer(*ss, port);
+  netMan->createServer(/**ss, */port);
   SDL_Delay(20);
 
@@ -196,5 +197,5 @@
   {
     netMan->synchronize();
-    SDL_Delay(500);
+    SDL_Delay(1000);
   }
 
@@ -229,5 +230,5 @@
   Synchronizeable* ss = new SimpleSync("Client\0");
 
-  netMan->establishConnection(ip, *ss);
+  netMan->establishConnection((const char*)"localhost", port/*,ip, *ss*/);
 
   for(;;)
@@ -280,4 +281,53 @@
   delete ss;
 
+  return 0;
+}
+
+
+int converter(int argc, char** argv)
+{
+  int x = 200564786;
+  printf("To convert: %i\n", x);
+  byte* res = Converter::intToByteArray(x);
+  for (int i = 0; i < 4; i++)
+    printf("%i  ", res[i]);
+  printf("\n");
+  
+  int z = Converter::byteArrayToInt(res);
+  
+  printf("ReConvert: %i\n", z);
+
+  
+  //float a = 5.4f;
+  //float b = 2.0f;
+  //printf("%f mod %f = %f", a, b, a % b);
+  
+  printf("\n");
+  
+  float y;
+  char* s;
+  
+  y = 12.0f;
+  s = Converter::floatToBinString(y);
+  printf("%f = ", y);
+  printf(s); printf("\n");
+  
+  y = 24549026.0f;
+  s = Converter::floatToBinString(y);
+  printf("%f = ", y);
+  printf(s); printf("\n");
+  
+  y = 12.4e20f;
+  s = Converter::floatToBinString(y);
+  printf("%f = ", y);
+  printf(s); printf("\n");
+  
+  y = 4.7824f;
+  s = Converter::floatToBinString(y);
+  printf("%f = ", y);
+  printf(s); printf("\n");
+  
+  
+  
   return 0;
 }
@@ -308,4 +358,6 @@
     else if (! strcmp( "--listen", argv[i]) || !strcmp("-l", argv[i]))
       return startListen(argc, argv);
+    else if (! strcmp( "--converter", argv[i]) || !strcmp("-o", argv[i]))
+      return converter(argc, argv);
   }
 
Index: /trunk/src/subprojects/network/read_sync.cc
===================================================================
--- /trunk/src/subprojects/network/read_sync.cc	(revision 6138)
+++ /trunk/src/subprojects/network/read_sync.cc	(revision 6139)
@@ -80,5 +80,5 @@
  *  read data from Synchronizeable
  */
-int ReadSync::readBytes(byte* data)
+int ReadSync::readBytes(byte* data, int maxLength, int * reciever)
 {
   return 0;
Index: /trunk/src/subprojects/network/read_sync.h
===================================================================
--- /trunk/src/subprojects/network/read_sync.h	(revision 6138)
+++ /trunk/src/subprojects/network/read_sync.h	(revision 6139)
@@ -17,5 +17,5 @@
 
     virtual void writeBytes(const byte* data, int length);
-    virtual int readBytes(byte* data);
+    virtual int readBytes(byte* data, int maxLength, int * reciever);
 
 
Index: /trunk/src/subprojects/network/simple_sync.cc
===================================================================
--- /trunk/src/subprojects/network/simple_sync.cc	(revision 6138)
+++ /trunk/src/subprojects/network/simple_sync.cc	(revision 6139)
@@ -86,5 +86,5 @@
  *  read data from Synchronizeable
  */
-int SimpleSync::readBytes(byte* data)
+int SimpleSync::readBytes(byte* data, int maxLength, int * reciever)
 {
   PRINTF(0)("SimpleSync: sent %i bytes of data\n", this->outLength);
Index: /trunk/src/subprojects/network/simple_sync.h
===================================================================
--- /trunk/src/subprojects/network/simple_sync.h	(revision 6138)
+++ /trunk/src/subprojects/network/simple_sync.h	(revision 6139)
@@ -17,5 +17,5 @@
 
     virtual void writeBytes(const byte* data, int length);
-    virtual int readBytes(byte* data);
+    virtual int readBytes(byte* data, int maxLength, int * reciever);
 
 
Index: /trunk/src/subprojects/network/write_sync.cc
===================================================================
--- /trunk/src/subprojects/network/write_sync.cc	(revision 6138)
+++ /trunk/src/subprojects/network/write_sync.cc	(revision 6139)
@@ -86,5 +86,5 @@
  *  read data from Synchronizeable
  */
-int WriteSync::readBytes(byte* data)
+int WriteSync::readBytes(byte* data, int maxLength, int * reciever)
 {
   PRINTF(0)("WriteSync: sent %i bytes of data\n", this->outLength);
Index: /trunk/src/subprojects/network/write_sync.h
===================================================================
--- /trunk/src/subprojects/network/write_sync.h	(revision 6138)
+++ /trunk/src/subprojects/network/write_sync.h	(revision 6139)
@@ -17,5 +17,5 @@
 
     virtual void writeBytes(const byte* data, int length);
-    virtual int readBytes(byte* data);
+    virtual int readBytes(byte* data, int maxLength, int * reciever);
 
 
Index: /trunk/src/util/loading/game_loader.cc
===================================================================
--- /trunk/src/util/loading/game_loader.cc	(revision 6138)
+++ /trunk/src/util/loading/game_loader.cc	(revision 6139)
@@ -46,5 +46,5 @@
 /**
  *  simple constructor
-*/
+ */
 GameLoader::GameLoader ()
 {
@@ -57,5 +57,5 @@
 /**
  *  simple deconstructor
-*/
+ */
 GameLoader::~GameLoader ()
 {
@@ -69,7 +69,7 @@
  *  this class is a singleton class
  * @returns an instance of itself
-
-   if you are unsure about singleton classes, check the theory out on the internet :)
-*/
+ *
+ * if you are unsure about singleton classes, check the theory out on the internet :)
+ */
 GameLoader* GameLoader::getInstance()
 {
@@ -81,5 +81,5 @@
 /**
  *  initializes the GameLoader
-*/
+ */
 ErrorMessage GameLoader::init()
 {
@@ -100,7 +100,7 @@
  * @param fileName to be loaded
  * @returns the loaded campaign
-
-   this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
-*/
+ *
+ * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
+ */
 ErrorMessage GameLoader::loadCampaign(const char* fileName)
 {
@@ -112,8 +112,25 @@
       delete[] campaignName;
     }
-//   World* world0 = new World(DEBUG_WORLD_0);
-//   world0->setNextStoryID(WORLD_ID_GAMEEND);
-//   this->currentCampaign->addEntity(world0, WORLD_ID_2);
-}
+}
+
+
+/**
+ *  reads a campaign definition file into a campaign class
+ * @param fileName to be loaded
+ * @returns the loaded campaign
+ *
+ * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
+ */
+ErrorMessage GameLoader::loadNetworkCampaign(const char* fileName)
+{
+  ErrorMessage errorCode;
+  char* campaignName = ResourceManager::getFullName(fileName);
+  if (campaignName)
+  {
+    this->currentCampaign = this->fileToNetworkCampaign(campaignName);
+    delete[] campaignName;
+  }
+}
+
 
 /**
@@ -121,5 +138,5 @@
  * @param campaignID the identifier of the campaign.
  * @returns error message if not able to do so.
-*/
+ */
 ErrorMessage GameLoader::loadDebugCampaign(Uint32 campaignID)
 {
@@ -156,7 +173,7 @@
 
 /**
-  *  starts the current entity
-  * @returns error code if this action has caused a error
-*/
+ *  starts the current entity
+ * @returns error code if this action has caused a error
+ */
 ErrorMessage GameLoader::start()
 {
@@ -167,13 +184,13 @@
 
 /**
-  *  stops the current entity
-  * @returns error code if this action has caused a error
-
-    ATTENTION: this function shouldn't call other functions, or if so, they must return
-    after finishing. If you ignore or forget to do so, the current entity is not able to
-    terminate and it will run in the background or the ressources can't be freed or even
-    worse: are freed and the program will end in a segmentation fault!
-    hehehe, have ya seen it... :)
-*/
+ *  stops the current entity
+ * @returns error code if this action has caused a error
+ *
+ *  ATTENTION: this function shouldn't call other functions, or if so, they must return
+ *  after finishing. If you ignore or forget to do so, the current entity is not able to
+ *  terminate and it will run in the background or the ressources can't be freed or even
+ *  worse: are freed and the program will end in a segmentation fault!
+ *  hehehe, have ya seen it... :)
+ */
 void GameLoader::stop()
 {
@@ -184,9 +201,9 @@
 
 /**
-  *  pause the current entity
-  * @returns error code if this action has caused a error
-
-    this pauses the current entity or passes this call forth to the running entity.
-*/
+ *  pause the current entity
+ * @returns error code if this action has caused a error
+ *
+ * this pauses the current entity or passes this call forth to the running entity.
+ */
 ErrorMessage GameLoader::pause()
 {
@@ -198,9 +215,9 @@
 
 /**
-  *  resumes a pause
-  * @returns error code if this action has caused a error
-
-    this resumess the current entity or passes this call forth to the running entity.
-*/
+ *  resumes a pause
+ * @returns error code if this action has caused a error
+ *
+ *  this resumess the current entity or passes this call forth to the running entity.
+ */
 ErrorMessage GameLoader::resume()
 {
@@ -224,7 +241,7 @@
  * @param fileName to be loaded
  * @returns the loaded campaign
-
-   this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
-*/
+ *
+ * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
+ */
 Campaign* GameLoader::fileToCampaign(const char* fileName)
 {
@@ -273,4 +290,56 @@
 
 /**
+ *  reads a campaign definition file into a campaign class
+ * @param fileName to be loaded
+ * @returns the loaded campaign
+ *
+ *  this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
+ */
+Campaign* GameLoader::fileToNetworkCampaign(const char* fileName)
+{
+  /* do not entirely load the campaign. just the current world
+  before start of each world, it has to be initialized so it
+  can load everything it needs into memory then.
+  */
+
+  if( fileName == NULL)
+  {
+    PRINTF(2)("No filename specified for loading");
+    return NULL;
+  }
+
+  TiXmlDocument* XMLDoc = new TiXmlDocument( fileName);
+  // load the campaign document
+  if( !XMLDoc->LoadFile())
+  {
+      // report an error
+    PRINTF(1)("Could not load XML File %s: %s @ %d:%d\n", fileName, XMLDoc->ErrorDesc(), XMLDoc->ErrorRow(), XMLDoc->ErrorCol());
+    delete XMLDoc;
+    return NULL;
+  }
+
+  // check basic validity
+  TiXmlElement* root = XMLDoc->RootElement();
+  assert( root != NULL);
+
+  if( strcmp( root->Value(), "Campaign"))
+  {
+      // report an error
+    PRINTF(2)("Specified XML File is not an orxonox campaign file (Campaign element missing)\n");
+    delete XMLDoc;
+    return NULL;
+  }
+
+  // construct campaign
+  Campaign* c = new Campaign( root);
+
+  // free the XML data
+  delete XMLDoc;
+
+  return c;
+}
+
+
+/**
  *  handle keyboard commands
  * @param event the event to handle
@@ -312,6 +381,6 @@
 
 /**
-  \brief this changes to the next level
-*/
+ *  \brief this changes to the next level
+ */
 void GameLoader::nextLevel()
 {
@@ -322,8 +391,8 @@
 
 /**
-  \brief change to the previous level - not implemented
-
-  this propably useless
-*/
+ *  change to the previous level - not implemented
+ *
+ * this propably useless
+ */
 void GameLoader::previousLevel()
 {
Index: /trunk/src/util/loading/game_loader.h
===================================================================
--- /trunk/src/util/loading/game_loader.h	(revision 6138)
+++ /trunk/src/util/loading/game_loader.h	(revision 6139)
@@ -40,4 +40,5 @@
 {
 
+
  public:
   ~GameLoader ();
@@ -46,5 +47,4 @@
 
   ErrorMessage init();
-  ErrorMessage loadCampaign(const char* name);
   ErrorMessage start();
   void stop();
@@ -53,12 +53,13 @@
   ErrorMessage destroy();
 
+  ErrorMessage loadCampaign(const char* name);
+  ErrorMessage loadDebugCampaign(Uint32 campaignID);
+  ErrorMessage loadNetworkCampaign(const char* fileName);
+
   void nextLevel();
   void previousLevel();
 
-  /** \brief a world command to send to the GameLoader @param cmd the command */
-  bool worldCommand(Command* cmd);
-  ErrorMessage loadDebugCampaign(Uint32 campaignID);
+  void process(const Event &event);
 
-  void process(const Event &event);
 
  private:
@@ -66,4 +67,6 @@
 
   Campaign* fileToCampaign(const char* name);
+  Campaign* fileToNetworkCampaign(const char* fileName);
+
 
  private:
Index: /trunk/src/world_entities/camera.h
===================================================================
--- /trunk/src/world_entities/camera.h	(revision 6138)
+++ /trunk/src/world_entities/camera.h	(revision 6139)
@@ -8,5 +8,4 @@
 
 #include "p_node.h"
-#include "vector.h"
 #include "event_listener.h"
 
Index: /trunk/src/world_entities/spawning_point.cc
===================================================================
--- /trunk/src/world_entities/spawning_point.cc	(revision 6139)
+++ /trunk/src/world_entities/spawning_point.cc	(revision 6139)
@@ -0,0 +1,128 @@
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer:
+*/
+
+#include "spawning_point.h"
+#include "load_param.h"
+#include "factory.h"
+#include "compiler.h"
+#include "world.h" /* only temp. until the object manager is implemented*/
+
+/**
+ *  standard constructor
+ */
+SpawningPoint::SpawningPoint (World* world, const Vector& absCoordinate)
+{
+  this->world = world;
+  this->frequency = 0.5f;
+  this->seed = 0.0f;
+
+  this->init();
+}
+
+
+/**
+ *  constructor
+ */
+SpawningPoint::SpawningPoint (const Vector& position, float frequency,
+                              float seed, ClassID classID, World* world)
+{
+  this->frequency = frequency;
+  this->seed = seed;
+  this->classID = classID;
+  this->world = world;
+
+  this->init();
+}
+
+
+void SpawningPoint::init()
+{
+  this->countDown = 0.0f;
+}
+
+
+/**
+ *  deconstructor
+ */
+SpawningPoint::~SpawningPoint ()
+{}
+
+
+/**
+ * loads the WorldEntity Specific Parameters.
+ * @param root: the XML-Element to load the Data From
+ */
+void SpawningPoint::loadParams(const TiXmlElement* root)
+{
+  /* let the world entity its stuff first */
+  static_cast<WorldEntity*>(this)->loadParams(root);
+
+  /* now load the frequency */
+  LoadParam(root, "frequency", this, SpawningPoint, setSpawningFrequency)
+  .describe("sets the frequency of the spawning point")
+  .defaultValues(1, 1.0f);
+
+
+  /* now load the seed */
+  LoadParam(root, "randomseed", this, SpawningPoint, setPositionSeed)
+      .describe("sets the random position seed (variance in the spawning location around the position)")
+      .defaultValues(1, 0.0f);
+
+  /* now load the seed */
+/*  LoadParam(root, "classid", this, SpawningPoint, setSpawningEntity)
+      .describe("sets the class id of the entity to spawn")
+      .defaultValues(1, CL_WORLD_ENTITY);*/
+}
+
+
+/**
+ *  spawn the entity
+ */
+void SpawningPoint::spawn()
+{
+  PRINTF(5)("Spangingpoint creates a new Entity (id: %i, frequency: %f, seed: %f)\n", this->classID,
+            this->frequency, this->seed);
+  BaseObject* spawningEntity = Factory::fabricate(this->classID);
+  if( likely(this->world != NULL))
+    this->world->spawn(dynamic_cast<WorldEntity*>(spawningEntity));
+}
+
+
+/**
+ *  this method is called every frame
+ * @param time: the time in seconds that has passed since the last tick
+ *
+ * Handle all stuff that should update with time inside this method (movement, animation, etc.)
+ */
+void SpawningPoint::tick(float dt)
+{
+  this->countDown += dt;
+  if( this->countDown > this->frequency)
+  {
+    this->spawn();
+    this->countDown = 0.0f;
+  }
+}
+
+
+/**
+ *  the entity is drawn onto the screen with this function
+ *
+ * This is a central function of an entity: call it to let the entity painted to the screen.
+ * Just override this function with whatever you want to be drawn.
+ */
+void SpawningPoint::draw()
+{}
Index: /trunk/src/world_entities/spawning_point.h
===================================================================
--- /trunk/src/world_entities/spawning_point.h	(revision 6139)
+++ /trunk/src/world_entities/spawning_point.h	(revision 6139)
@@ -0,0 +1,47 @@
+/*!
+ * @file spawning_point.h
+ *  Definition of a spawning point within the game, used for network game
+ */
+
+
+#ifndef _SPAWNING_POINT
+#define _SPAWNING_POINT
+
+#include "world_entity.h"
+
+class World;
+class TiXmlElement;
+
+//! The spawning point for world entities
+class SpawningPoint : public WorldEntity {
+
+  public:
+    SpawningPoint (World* world, const Vector& absCoordinate = Vector(0.0, 0.0, 0.0));
+    SpawningPoint (const Vector& position, float frequency, float seed, ClassID classID, World* world);
+    virtual ~SpawningPoint ();
+    void init();
+
+    void loadParams(const TiXmlElement* root);
+
+    /**  sets the entity that is going to be spawned by this point @param classID: the id from the class_id.h file */
+    void SpawningPoint::setSpawningEntity(ClassID classID) { this->classID = classID; }
+    /** sets the frequency with which the point is going to spawn entities (1/sec) @param frequency: the frequency */
+    void SpawningPoint::setSpawningFrequency(float frequency) { this->frequency = frequency; }
+    /**  sets the seed of the position vector @param seed: the random seed around the given vector */
+    void SpawningPoint::setPositionSeed(float seed) { this->seed = seed; }
+
+    void spawn();
+
+    virtual void tick(float dt);
+    virtual void draw();
+
+  private:
+    float                frequency;                      //!< the frequency for entity spawning
+    float                countDown;                      //!< the timer that counts down until the next spawn
+    float                seed;                           //!< the random seed of the position
+    ClassID              classID;                        //!< the classid of the entity to spawn
+    World*               world;                          //!< reference to the world it belongs to (or in the future: the object manager)
+
+};
+
+#endif /* _SPAWNING_POINT */
